Scriptname _SLSubmitAutoSurrenderEffect extends activemagiceffect  

_SLSubmitQuest Property _SLQuest Auto
_SLSubmitFunctions Property _SLFunctions Auto
_SLSubmitConfig Property _SLConfig Auto
_SLSubmitScene Property _SLScene Auto
Float Property ChanceSpan Auto
Float Property HealthSpan Auto
Float Property ChancePoint Auto
GlobalVariable Property SuccessChance  Auto  
GlobalVariable Property SuccessRoll  Auto  
GlobalVariable Property _SLSubmitSurrenderGlobal  Auto
SPELL Property _SLSubmitAssign  Auto  
SPELL Property _SLSubmitSurrender  Auto  
Race Property Werewolf Auto
Actor Property PlayerRef Auto
Bool Dawnguard
Race DLC1VampireBeast
Bool Bleedout
Bool Brawling
Weapon Property Fists Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	_SLScene.WRT(1.0)
	If (_SLConfig.NoDeathActive)
		PlayerRef.GetActorBase().SetProtected()
	EndIf
	Debug.Notification("Auto Surrender is Enabled!")
	Bleedout = True
	If (_SLQuest.Dawnguard)
		DLC1VampireBeast = Game.GetFormFromFile(0x283A, "Dawnguard.esm") as Race
	EndIf
EndEvent
 
Event OnEffectFinish(Actor akTarget, Actor akCaster)
	_SLScene.WRT(1.0)
	PlayerRef.GetActorBase().SetProtected(False)
	Debug.Notification("Auto Surrender is Disabled!")
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If (akBaseObject.GetFormID() == 500)
		PlayerRef.GetActorBase().SetProtected(False)
		Brawling = True
		If(Brawling && _SLConfig.debugActive)
			Debug.Notification("Brawling!")
		EndIf
		RegisterForSingleUpdate(0.5)
	EndIf
EndEvent

Event OnUpdate()
	If (Brawling)
		If (!PlayerRef.IsInCombat())
			_SLScene.WRT(5.0)
			PlayerRef.UnequipItemEx(Fists, 1)
			PlayerRef.GetActorBase().SetProtected()
			Brawling = False
			If(!Brawling && _SLConfig.debugActive)
				Debug.Notification("Not Brawling!")
			EndIf
		Else
			RegisterForSingleUpdate(0.5)
		EndIf
	EndIf	
EndEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	If (!Brawling && _SLConfig.AutoSubmit > 0)
		If (_SLConfig.modActive && ((PlayerRef.GetAV("Health")/PlayerRef.GetBaseAV("Health")) < (_SLConfig.AutoSubmit)) && PlayerRef.GetRace() != Werewolf && PlayerRef.GetRace() != DLC1VampireBeast && _SLSubmitSurrenderGlobal.GetValue() == 0)
			ChanceSpan = 100 - _SLConfig.AutoSubmitChance
			HealthSpan = _SLConfig.AutoSubmit - (PlayerRef.GetAV("Health")/PlayerRef.GetBaseAV("Health"))
			ChancePoint = ChanceSpan / _SLConfig.AutoSubmit
			SuccessChance.SetValue(_SLConfig.AutoSubmitChancePercent + ChancePoint * HealthSpan)
			If (SuccessChance.GetValue() > 100.0)
				SuccessChance.SetValue(100.0)
			EndIf
			SuccessRoll.SetValue(Utility.RandomInt(0, 100))
			If ( SuccessChance.GetValue() > SuccessRoll.GetValue())
				_SLFunctions.ClearAssailants()
				_SLSubmitSurrenderGlobal.SetValue(1)
				_SLSubmitAssign.Cast(PlayerRef)
				_SLFunctions.Surrender()
			EndIf
		EndIf
	EndIf
EndEvent

Event OnEnterBleedout()
	If (!Brawling && _SLConfig.NoDeathActive && _SLConfig.modActive && PlayerRef.GetRace() != Werewolf && PlayerRef.GetRace() != DLC1VampireBeast)
		If (Bleedout)
			PlayerRef.GetActorBase().SetInvulnerable()
			_SLScene.WRT(0.1)
			PlayerRef.ResetHealthAndLimbs()
			_SLScene.WRT(1.0)
			Debug.SendAnimationEvent(PlayerRef, "BleedOutStart")
			If (_SLSubmitSurrenderGlobal.GetValue() == 0)
				_SLSubmitSurrenderGlobal.SetValue(1)
				_SLSubmitAssign.Cast(PlayerRef)
				_SLFunctions.Surrender()
			EndIf
			_SLScene.WRT(5.0)
			PlayerRef.GetActorBase().SetInvulnerable(False)
		EndIf
		If (_SLSubmitSurrenderGlobal.GetValue() != 2)
			Bleedout = False
			If(_SLConfig.debugActive)
				Debug.Notification("Your wounds are mortal... ")
			EndIf
			_SLScene.WRT(3.0)
			PlayerRef.GetActorBase().SetProtected(False)
			PlayerRef.KillEssential()
		EndIf
	ElseIf (PlayerRef.GetRace() == Werewolf || PlayerRef.GetRace() == DLC1VampireBeast)
		PlayerRef.GetActorBase().SetProtected(False)
		PlayerRef.KillEssential()
	EndIf
EndEvent