Scriptname _SLSubmitConfig extends ski_configbase  

_SLSubmitQuest property _SLQuest auto
GlobalVariable Property _SLSubmitDisableRapeGlobal  Auto
GlobalVariable Property _SLSubmitDisableSpeechGlobal  Auto
GlobalVariable Property _SLSubmitFollowerMorality  Auto 
GlobalVariable Property _SLSubmitGenderMaleGlobal  Auto 
GlobalVariable Property _SLSubmitGenderFemaleGlobal  Auto 
SPELL Property _SLSubmitAutoSurrender  Auto  
MagicEffect Property _SLAutoSurrender  Auto
Actor Property PlayerRef Auto

int keyMapOptionID = 0
int keySurrenderOptionID = 0
int enableModOptionID = 0
int enableDebugOptionID = 0
int enableAttackOptionID = 0
int enableGrappleOptionID = 0
int enableSpeechOptionID = 0
int enableRobOptionID = 0
int enableRapeOptionID = 0
int enableSurrenderOptionID = 0
int enableVictimOptionID = 0
int enableVictimRapeOptionID = 0
int enableStealOptionID = 0
int enableGuardOptionID = 0
int enableHardcoreOptionID = 0
int enableRepeatOptionID = 0
int enableNoDeathOptionID = 0
int enableVampireOptionID = 0
int enableAutoSurrenderOptionID = 0
int enableAmbushSexOptionID = 0

int property currentKeyCode	auto	;NP7
bool property modActive auto
bool property debugActive auto
bool property AttackActive auto
bool property GrappleActive auto
bool property SpeechActive auto
bool property RobActive auto
bool property RapeActive auto
bool property SurrenderActive auto
bool property VictimActive auto
bool property VictimRapeActive auto
bool property StealActive auto
bool property GuardActive auto
bool property HardcoreActive auto
bool property RepeatActive auto
bool property NoDeathActive auto
bool property VampireActive auto
bool property AutoSurrenderActive auto
bool property AmbushSexActive auto
float property ShoutCooldown auto
float property CDifficulty auto
float property SDifficulty auto
float property Morality auto
float property Bribery auto
float property Escape auto
float property Creature auto
float property Gender auto
float property RepeatRate auto
float property Range auto
float property AutoSubmitPercent auto
float property AutoSubmit auto
float property AutoSubmitChancePercent auto
float property AutoSubmitChance auto
int oidCooldown
int oidCDifficulty
int oidSDifficulty
int oidMorality
int oidBribery
int oidEscape
int oidCreature
int oidGender
int oidRepeatRate
int oidRange
int oidAutoSubmit
int oidAutoSubmitChance

Event OnPageReset(String page)
	SetCursorFillMode(LEFT_TO_RIGHT)
	AddHeaderOption("$_SLSubmit_General")
	AddHeaderOption("")
	keyMapOptionID = AddKeymapOption("$_SLSubmit_SubmitKey", currentKeyCode)
	enableModOptionID = AddToggleOption("$_SLSubmit_ModActive", modActive)
	enableDebugOptionID = AddToggleOption("$_SLSubmit_DebugNotificationActive", debugActive)
	enableRapeOptionID = AddToggleOption("$_SLSubmit_RapeContentActive", RapeActive)
	enableSpeechOptionID = AddToggleOption("$_SLSubmit_SpeechDialogActive", SpeechActive)
	oidBribery = AddSliderOption("$_SLSubmit_BriberyMultiple", Bribery, "$_SLSubmit_{0}Bribery")
	oidSDifficulty = AddSliderOption("$_SLSubmit_SDifficultyAdjust", SDifficulty, "$_SLSubmit_+{0}%SSuccessChance")
	oidCDifficulty = AddSliderOption("$_SLSubmit_CDifficultyAdjust", CDifficulty, "$_SLSubmit_+{0}%CSuccessChance")
	oidGender = AddSliderOption("$_SLSubmit_GenderLevel", Gender, "$_SLSubmit_{0}Gender")
	oidMorality = AddSliderOption("$_SLSubmit_FollowerMorality", Morality, "$_SLSubmit_{0}Morality")
	AddHeaderOption("$_SLSubmit_PlayerVictor")
	AddHeaderOption("")
	enableAttackOptionID = AddToggleOption("$_SLSubmit_AttackActive", AttackActive)
	enableRobOptionID = AddToggleOption("$_SLSubmit_AutomaticLootActive", RobActive)
	enableGrappleOptionID = AddToggleOption("$_SLSubmit_SubmitGrappleActive", GrappleActive)
	enableGuardOptionID = AddToggleOption("$_SLSubmit_GuardActive", GuardActive)
	enableAmbushSexOptionID = AddToggleOption("$_SLSubmit_AmbushSexActive", AmbushSexActive)
	enableVampireOptionID = AddToggleOption("$_SLSubmit_VampireActive", VampireActive)	
	oidCooldown = AddSliderOption("$_SLSubmit_SubmitCooldown", ShoutCooldown, "$_SLSubmit_{0}Seconds")
	enableVictimOptionID = AddToggleOption("$_SLSubmit_FemalePlayer/FollowerInVictimRole", VictimActive)
	AddHeaderOption("$_SLSubmit_PlayerVictim")
	AddHeaderOption("")
	enableSurrenderOptionID = AddToggleOption("$_SLSubmit_PlayerSubmitActive", SurrenderActive)
	oidAutoSubmit = AddSliderOption("$_SLSubmit_AutoSubmit", AutoSubmitPercent, "$_SLSubmit_{0}AutoSubmit")
	enableAutoSurrenderOptionID = AddToggleOption("$_SLSubmit_AutoSubmitActive", AutoSurrenderActive)
	oidAutoSubmitChance = AddSliderOption("$_SLSubmit_AutoSubmitChance", AutoSubmitChancePercent, "$_SLSubmit_{0}AutoSubmitChance")
	enableNoDeathOptionID = AddToggleOption("$_SLSubmit_NoDeathActive", NoDeathActive)
	oidRange = AddSliderOption("$_SLSubmit_RangeLevel", Range, "$_SLSubmit_{0}Range")
	enableStealOptionID = AddToggleOption("$_SLSubmit_StealGearActive", StealActive)
	oidCreature = AddSliderOption("$_SLSubmit_CreatureLevel", Creature, "$_SLSubmit_{0}Creature")
	enableHardcoreOptionID = AddToggleOption("$_SLSubmit_HardcoreActive", HardcoreActive)
	oidEscape = AddSliderOption("$_SLSubmit_EscapeLevel", Escape, "$_SLSubmit_{0}Escape")
	enableRepeatOptionID = AddToggleOption("$_SLSubmit_RepeatActive", RepeatActive)
	oidRepeatRate = AddSliderOption("$_SLSubmit_RepeatRateLevel", RepeatRate, "$_SLSubmit_{0}RepeatRate")
	enableVictimRapeOptionID = AddToggleOption("$_SLSubmit_VictimRapeActive", VictimRapeActive)
EndEvent

Event OnOptionKeyMapChange(int option, int keyCode, String conflictControl, String conflictName)
	If(option == keyMapOptionID)
		currentKeyCode = keyCode
		SetKeyMapOptionValue(keyMapOptionID, currentKeyCode)
		_SLQuest.SetSubmitKeyCode(currentKeyCode)
	EndIf
EndEvent

int Function GetVersion()
	return 1
EndFunction

Event OnOptionDefault(int option)
	If(option == keyMapOptionID)
		currentKeyCode = 71	;NP7
		SetKeyMapOptionValue(keyMapOptionID, currentKeyCode)
		_SLQuest.setSubmitKeyCode(currentKeyCode)
	ElseIf(option == enableModOptionID)
		If(!modActive)
			modActive = true
			SetToggleOptionValue(enableModOptionID, modActive)
			_SLQuest.activateMod()
		EndIf
	ElseIf(option == enableDebugOptionID)
		If(!debugActive)
			debugActive = true
			SetToggleOptionValue(enableDebugOptionID, debugActive)
		EndIf
	ElseIf(option == enableAttackOptionID)
		If(!AttackActive)
			AttackActive = true
			SetToggleOptionValue(enableAttackOptionID, AttackActive)
		EndIf
	ElseIf(option == enableGrappleOptionID)
		If(!GrappleActive)
			GrappleActive = false
			SetToggleOptionValue(enableGrappleOptionID, GrappleActive)
		EndIf
	ElseIf(option == enableSpeechOptionID)
		If(!SpeechActive)
			SpeechActive = true
			SetToggleOptionValue(enableSpeechOptionID, SpeechActive)
		EndIf
	ElseIf(option == enableRobOptionID)
		If(!RobActive)
			RobActive = true
			SetToggleOptionValue(enableRobOptionID, RobActive)
		EndIf
	ElseIf(option == enableRapeOptionID)
		If(!RapeActive)
			RapeActive = true
			SetToggleOptionValue(enableRapeOptionID, RapeActive)
		EndIf
	ElseIf(option == enableSurrenderOptionID)
		If(!SurrenderActive)
			SurrenderActive = true
			SetToggleOptionValue(enableSurrenderOptionID, SurrenderActive)
		EndIf
	ElseIf(option == enableStealOptionID)
		If(!StealActive)
			StealActive = false
			SetToggleOptionValue(enableStealOptionID, StealActive)
		EndIf
	ElseIf(option == enableVictimOptionID)
		If(!VictimActive)
			VictimActive = false
			SetToggleOptionValue(enableVictimOptionID, VictimActive)
		EndIf
	ElseIf(option == enableVictimRapeOptionID)
		If(!VictimRapeActive)
			VictimRapeActive = false
			SetToggleOptionValue(enableVictimRapeOptionID, VictimRapeActive)
		EndIf
	ElseIf(option == enableGuardOptionID)
		If(!GuardActive)
			GuardActive = true
			SetToggleOptionValue(enableGuardOptionID, GuardActive)
		EndIf
	ElseIf(option == enableHardcoreOptionID)
		If(!HardcoreActive)
			HardcoreActive = false
			SetToggleOptionValue(enableHardcoreOptionID, HardcoreActive)
		EndIf
	ElseIf(option == enableRepeatOptionID)
		If(!RepeatActive)
			RepeatActive = true
			SetToggleOptionValue(enableRepeatOptionID, RepeatActive)
		EndIf
	ElseIf(option == enableNoDeathOptionID)
		If(!NoDeathActive)
			NoDeathActive = true
			SetToggleOptionValue(enableNoDeathOptionID, NoDeathActive)
		EndIf
	ElseIf(option == enableVampireOptionID)
		If(!VampireActive)
			VampireActive = true
			SetToggleOptionValue(enableVampireOptionID, VampireActive)
		EndIf
	ElseIf(option == enableAmbushSexOptionID)
		If(!AmbushSexActive)
			AmbushSexActive = true
			SetToggleOptionValue(enableAmbushSexOptionID, AmbushSexActive)
		EndIf
	ElseIf(option == enableAutoSurrenderOptionID)
		If(!AutoSurrenderActive)
			AutoSurrenderActive = false
			SetToggleOptionValue(enableAutoSurrenderOptionID, AutoSurrenderActive)
		EndIf
	EndIf
EndEvent

Event OnOptionHighlight(int option)
	If(option == keyMapOptionID)
		SetInfoText("$_SLSubmit_Hotkey")
	ElseIf(option == enableModOptionID)
		If(!modActive)
			SetInfoText("$_SLSubmit_ModOff")
		Else
			SetInfoText("$_SLSubmit_ModOn")
		EndIf
	ElseIf(option == enableDebugOptionID)
		If(!debugActive)
			SetInfoText("$_SLSubmit_DebugOff")
		Else
			SetInfoText("$_SLSubmit_DebugOn")
		EndIf
	ElseIf(option == enableAttackOptionID)
		If(!AttackActive)
			SetInfoText("$_SLSubmit_AttackOff")
		Else
			SetInfoText("$_SLSubmit_AttackOn")
		EndIf
	ElseIf(option == oidCooldown)
		SetInfoText("$_SLSubmit_Cooldown")
	ElseIf(option == oidCDifficulty)
		SetInfoText("$_SLSubmit_CDifficulty")
	ElseIf(option == oidSDifficulty)
		SetInfoText("$_SLSubmit_SDifficulty")
	ElseIf(option == oidMorality)
		SetInfoText("$_SLSubmit_Morality")
	ElseIf(option == oidAutoSubmit)
		SetInfoText("$_SLSubmit_Submit")
	ElseIf(option == oidAutoSubmitChance)
		SetInfoText("$_SLSubmit_SubmitChance")
	ElseIf(option == oidBribery)
		SetInfoText("$_SLSubmit_Bribery")
	ElseIf(option == oidEscape)
		SetInfoText("$_SLSubmit_Escape")
	ElseIf(option == oidCreature)
		SetInfoText("$_SLSubmit_Creature")
	ElseIf(option == oidGender)
		SetInfoText("$_SLSubmit_Gender")
	ElseIf(option == oidRepeatRate)
		SetInfoText("$_SLSubmit_RepeatRate")
	ElseIf(option == oidRange)
		SetInfoText("$_SLSubmit_Range")
	ElseIf(option == enableGrappleOptionID)
		If(!GrappleActive)
			SetInfoText("$_SLSubmit_GrappleOff")
		Else
			SetInfoText("$_SLSubmit_GrappleOn")
		EndIf
	ElseIf(option == enableAmbushSexOptionID)
		If(!AmbushSexActive)
			SetInfoText("$_SLSubmit_AmbushOff")
		Else
			SetInfoText("$_SLSubmit_AmbushOn")
		EndIf
	ElseIf(option == enableSpeechOptionID)
		If(!SpeechActive)
			SetInfoText("$_SLSubmit_SpeechOff")
		Else
			SetInfoText("$_SLSubmit_SpeechOn")
		EndIf
	ElseIf(option == enableRobOptionID)
		If(!RobActive)
			SetInfoText("$_SLSubmit_RobOff")
		Else
			SetInfoText("$_SLSubmit_RobOn")
		EndIf
	ElseIf(option == enableRapeOptionID)
		If(!RapeActive)
			SetInfoText("$_SLSubmit_RapeOff")
		Else
			SetInfoText("$_SLSubmit_RapeOn")
		EndIf
	ElseIf(option == enableSurrenderOptionID)
		If(!SurrenderActive)
			SetInfoText("$_SLSubmit_PlayerOff")
		Else
			SetInfoText("$_SLSubmit_PlayerOn")
		EndIf
	ElseIf(option == enableAutoSurrenderOptionID)
		If(!AutoSurrenderActive)
			SetInfoText("$_SLSubmit_AutoOff")
		Else
			SetInfoText("$_SLSubmit_AutoOn")
		EndIf
	ElseIf(option == enableStealOptionID)
		If(!StealActive)
			SetInfoText("$_SLSubmit_StealOff")
		Else
			SetInfoText("$_SLSubmit_StealOn")
		EndIf
	ElseIf(option == enableVictimOptionID)
		If(!VictimActive)
			SetInfoText("$_SLSubmit_FemaleOff")
		Else
			SetInfoText("$_SLSubmit_FemaleOn")
		EndIf
	ElseIf(option == enableVictimRapeOptionID)
		If(!VictimRapeActive)
			SetInfoText("$_SLSubmit_VictimRapeOff")
		Else
			SetInfoText("$_SLSubmit_VictimRapeOn")
		EndIf
	ElseIf(option == enableGuardOptionID)
		If(!GuardActive)
			SetInfoText("$_SLSubmit_GuardOff")
		Else
			SetInfoText("$_SLSubmit_GuardOn")
		EndIf
	ElseIf(option == enableHardcoreOptionID)
		If(!HardcoreActive)
			SetInfoText("$_SLSubmit_HardcoreOff")
		Else
			SetInfoText("$_SLSubmit_HardcoreOn")
		EndIf
	ElseIf(option == enableRepeatOptionID)
		If(!RepeatActive)
			SetInfoText("$_SLSubmit_RepeatOff")
		Else
			SetInfoText("$_SLSubmit_RepeatOn")
		EndIf
	ElseIf(option == enableNoDeathOptionID)
		If(!NoDeathActive)
			SetInfoText("$_SLSubmit_NoDeathOff")
		Else
			SetInfoText("$_SLSubmit_NoDeathOn")
		EndIf
	ElseIf(option == enableVampireOptionID)
		If(!VampireActive)
			SetInfoText("$_SLSubmit_VampireOff")
		Else
			SetInfoText("$_SLSubmit_VampireOn")
		EndIf
	EndIf
EndEvent

Event OnOptionSelect(int option)
	If(option == enableModOptionID)
		modActive = !modActive
		SetToggleOptionValue(enableModOptionID, modActive)
		If(modActive)
			_SLQuest.activateMod()
		Else
			_SLQuest.deactivateMod()
		EndIf
	EndIf
	If(option == enableDebugOptionID)
		debugActive = !debugActive
		SetToggleOptionValue(enableDebugOptionID, debugActive)
	EndIf
	If(option == enableAttackOptionID)
		AttackActive = !AttackActive
		SetToggleOptionValue(enableAttackOptionID, AttackActive)
	EndIf
	If(option == enableGrappleOptionID)
		GrappleActive = !GrappleActive
		SetToggleOptionValue(enableGrappleOptionID, GrappleActive)
	EndIf
	If(option == enableAmbushSexOptionID)
		AmbushSexActive = !AmbushSexActive
		SetToggleOptionValue(enableAmbushSexOptionID, AmbushSexActive)
	EndIf
	If(option == enableSpeechOptionID)
		SpeechActive = !SpeechActive
		SetToggleOptionValue(enableSpeechOptionID, SpeechActive)
		If(SpeechActive)
			_SLSubmitDisableSpeechGlobal.SetValue(0)
		Else
			_SLSubmitDisableSpeechGlobal.SetValue(1)
		EndIf
	EndIf
	If(option == enableRobOptionID)
		RobActive = !RobActive
		SetToggleOptionValue(enableRobOptionID, RobActive)
	EndIf
	If(option == enableRapeOptionID)
		RapeActive = !RapeActive
		SetToggleOptionValue(enableRapeOptionID, RapeActive)
		If(RapeActive)
			_SLSubmitDisableRapeGlobal.SetValue(0)
		Else
			_SLSubmitDisableRapeGlobal.SetValue(1)
		EndIf
	EndIf
	If(option == enableSurrenderOptionID)
		SurrenderActive = !SurrenderActive
		SetToggleOptionValue(enableSurrenderOptionID, SurrenderActive)
		If (SurrenderActive && AutoSurrenderActive)
			If (!PlayerRef.HasMagicEffect(_SLAutoSurrender))
				PlayerRef.AddSpell(_SLSubmitAutoSurrender,false)
			EndIf
		Else
			If (PlayerRef.HasMagicEffect(_SLAutoSurrender))
				PlayerRef.RemoveSpell(_SLSubmitAutoSurrender)
			EndIf
		EndIf
	EndIf
	If(option == enableAutoSurrenderOptionID)
		AutoSurrenderActive = !AutoSurrenderActive
		SetToggleOptionValue(enableAutoSurrenderOptionID, AutoSurrenderActive)
		If (AutoSurrenderActive)
			If (!PlayerRef.HasMagicEffect(_SLAutoSurrender))
				PlayerRef.AddSpell(_SLSubmitAutoSurrender,false)
			EndIf
		Else
			If (PlayerRef.HasMagicEffect(_SLAutoSurrender))
				PlayerRef.RemoveSpell(_SLSubmitAutoSurrender)
			EndIf
		EndIf
	EndIf
	If(option == enableStealOptionID)
		StealActive = !StealActive
		SetToggleOptionValue(enableStealOptionID, StealActive)
	EndIf
	If(option == enableVictimOptionID)
		VictimActive = !VictimActive
		SetToggleOptionValue(enableVictimOptionID, VictimActive)
	EndIf
	If(option == enableVictimRapeOptionID)
		VictimRapeActive = !VictimRapeActive
		SetToggleOptionValue(enableVictimRapeOptionID, VictimRapeActive)
	EndIf
	If(option == enableGuardOptionID)
		GuardActive = !GuardActive
		SetToggleOptionValue(enableGuardOptionID, GuardActive)
	EndIf
	If(option == enableHardcoreOptionID)
		HardcoreActive = !HardcoreActive
		SetToggleOptionValue(enableHardcoreOptionID, HardcoreActive)
	EndIf
	If(option == enableRepeatOptionID)
		RepeatActive = !RepeatActive
		SetToggleOptionValue(enableRepeatOptionID, RepeatActive)
	EndIf
	If(option == enableNoDeathOptionID)
		NoDeathActive = !NoDeathActive
		SetToggleOptionValue(enableNoDeathOptionID, NoDeathActive)
		If (NoDeathActive)
			If (PlayerRef.HasMagicEffect(_SLAutoSurrender) && !PlayerRef.GetActorBase().IsProtected())
				PlayerRef.GetActorBase().SetProtected()
			EndIf
		Else
			If (PlayerRef.GetActorBase().IsProtected())
				PlayerRef.GetActorBase().SetProtected(False)
			EndIf
		EndIf
	EndIf
	If(option == enableVampireOptionID)
		VampireActive = !VampireActive
		SetToggleOptionValue(enableVampireOptionID, VampireActive)
	EndIf
EndEvent

Event OnOptionSliderOpen(int option)
	If option == oidCooldown
		SetSliderDialogStartValue(ShoutCooldown)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(5.0, 15.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidCDifficulty
		SetSliderDialogStartValue(CDifficulty)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(-25.0, 25.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidSDifficulty
		SetSliderDialogStartValue(SDifficulty)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(-25.0, 25.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidMorality
		SetSliderDialogStartValue(Morality)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 3.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidAutoSubmit
		SetSliderDialogStartValue(AutoSubmitPercent)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidAutoSubmitChance
		SetSliderDialogStartValue(AutoSubmitChancePercent)
		SetSliderDialogDefaultValue(100.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidBribery
		SetSliderDialogStartValue(Bribery)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidEscape
		SetSliderDialogStartValue(Escape)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, 5.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidCreature
		SetSliderDialogStartValue(Creature)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 2.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidGender
		SetSliderDialogStartValue(Gender)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 2.0)
		SetSliderDialogInterval(1.0)
	ElseIf option == oidRepeatRate
		SetSliderDialogStartValue(RepeatRate)
		SetSliderDialogDefaultValue(15.0)
		SetSliderDialogRange(5.0, 15.0)
		SetSliderDialogInterval(5.0)
	ElseIf option == oidRange
		SetSliderDialogStartValue(Range)
		SetSliderDialogDefaultValue(500.0)
		SetSliderDialogRange(25.0, 2000.0)
		SetSliderDialogInterval(25.0)
	EndIf
EndEvent

Event OnOptionSliderAccept(int option, float value)
	If option == oidCooldown
		ShoutCooldown = value
		SetSliderOptionValue(oidCooldown, ShoutCooldown, "$_SLSubmit_{0}Seconds")
	ElseIf option == oidCDifficulty
		CDifficulty = value
		SetSliderOptionValue(oidCDifficulty, CDifficulty, "$_SLSubmit_+{0}%CSuccessChance")
	ElseIf option == oidSDifficulty
		SDifficulty = value
		SetSliderOptionValue(oidSDifficulty, SDifficulty, "$_SLSubmit_+{0}%SSuccessChance")
	ElseIf option == oidMorality
		Morality = value
		_SLSubmitFollowerMorality.SetValue(Morality)
		SetSliderOptionValue(oidMorality, Morality, "$_SLSubmit_{0}Morality")
	ElseIf option == oidAutoSubmit
		AutoSubmit = value
		AutoSubmitPercent = value
		SetSliderOptionValue(oidAutoSubmit, AutoSubmitPercent, "$_SLSubmit_{0}AutoSubmit")
		AutoSubmit = AutoSubmitPercent/100
	ElseIf option == oidAutoSubmitChance
		AutoSubmitChancePercent = value
		SetSliderOptionValue(oidAutoSubmitChance, AutoSubmitChancePercent, "$_SLSubmit_{0}AutoSubmitChance")
		AutoSubmitChance = AutoSubmitChancePercent/100
	ElseIf option == oidBribery
		Bribery = value
		SetSliderOptionValue(oidBribery, Bribery, "$_SLSubmit_{0}Bribery")
	ElseIf option == oidEscape
		Escape = value
		SetSliderOptionValue(oidEscape, Escape, "$_SLSubmit_{0}Escape")
	ElseIf option == oidCreature
		Creature = value
		SetSliderOptionValue(oidCreature, Creature, "$_SLSubmit_{0}Creature")
	ElseIf option == oidGender
		Gender = value
		SetSliderOptionValue(oidGender, Gender, "$_SLSubmit_{0}Gender")
		If (Gender == 0)
			If (PlayerRef.GetActorBase().GetSex() == 0)
				_SLSubmitGenderMaleGlobal.SetValue(0)
				_SLSubmitGenderFemaleGlobal.SetValue(1)
			Else
				_SLSubmitGenderMaleGlobal.SetValue(1)
				_SLSubmitGenderFemaleGlobal.SetValue(0)
			EndIf
		ElseIf (Gender == 1)
			If (PlayerRef.GetActorBase().GetSex() == 0)
				_SLSubmitGenderMaleGlobal.SetValue(1)
				_SLSubmitGenderFemaleGlobal.SetValue(0)
			Else
				_SLSubmitGenderMaleGlobal.SetValue(0)
				_SLSubmitGenderFemaleGlobal.SetValue(1)
			EndIf
		Else
			_SLSubmitGenderMaleGlobal.SetValue(1)
			_SLSubmitGenderFemaleGlobal.SetValue(1)
		EndIf
	ElseIf option == oidRepeatRate
		RepeatRate = value
		SetSliderOptionValue(oidRepeatRate, RepeatRate, "$_SLSubmit_{0}RepeatRate")
	ElseIf option == oidRange
		Range = value
		SetSliderOptionValue(oidRange, Range, "$_SLSubmit_{0}Range")
	EndIf
EndEvent