Scriptname _SLSubmitEscapeEffect extends ActiveMagicEffect  

import game

_SLSubmitConfig Property _SLConfig auto
_SLSubmitQuest Property _SLQuest auto
_SLSubmitScene Property _SLScene auto

GlobalVariable Property SuccessChance  Auto  
GlobalVariable Property SuccessRoll  Auto  
SPELL Property _SLSubmitBoundEnd  Auto
GlobalVariable Property BoundGlobal  Auto
GlobalVariable Property EscapeBonus  Auto
GlobalVariable Property _SLSubmitSurrenderGlobal  Auto
SPELL Property _SLSubmitAssign  Auto  
SPELL Property _SLSubmitSurrender  Auto  
Perk Property QuickHands Auto
Actor Property PlayerRef Auto
Armor Property _SLSubmitCuffs Auto

Event OnEffectStart(actor Target, actor Caster)
	If (PlayerRef.GetItemCount(_SLSubmitCuffs) == 0)
; // Code for the success algorithm
		If (_SLQuest.ZazPack)
			Debug.SendAnimationEvent(PlayerRef, "ZaZAPCAO054")
		Else
			Debug.SendAnimationEvent(PlayerRef, "IdleHandsBehindBack")
			_SLScene.WRT(0.25)
			Debug.SendAnimationEvent(PlayerRef, "IdleBoundKneesStart")
		EndIf
		_SLQuest.EscapeChance()
; // Code for what happens on success
		If (SuccessChance.GetValue() >= SuccessRoll.GetValue())
			If(_SLConfig.debugActive)
				Debug.Notification(SuccessChance.GetValue() + "% success chance, rolled under with " + SuccessRoll.GetValue() + "%.  Success!")
			EndIf
			AdvanceSkill("Lockpicking", (_SLConfig.Escape + 1.0))
			BoundGlobal.SetValue(0)
			_SLSubmitBoundEnd.Cast(PlayerRef)
		Else
; // Code for what happens on failure
			If(_SLConfig.debugActive)
				Debug.Notification(SuccessChance.GetValue() + "% success chance, rolled too high with " + SuccessRoll.GetValue() + "%.  Failure!")
			EndIf
			AdvanceSkill("Lockpicking", 0.25)
			EscapeBonus.SetValue(EscapeBonus.GetValue() + 1.0)
			_SLScene.WRT(0.1)
			If ((PlayerRef.HasPerk(QuickHands) && (SuccessRoll.GetValue() - SuccessChance.GetValue()) >= (50 + _SLConfig.CDifficulty)) || (!PlayerRef.HasPerk(QuickHands) && (SuccessRoll.GetValue() - SuccessChance.GetValue()) >= (25 + _SLConfig.CDifficulty)))
				If (_SLConfig.RepeatActive)
					If(_SLConfig.debugActive)
						Debug.Notification("Your attempted escape may not have gone unnoticed...")
					EndIf
					_SLSubmitSurrenderGlobal.SetValue(1)
					_SLSubmitAssign.Cast(PlayerRef)
					_SLSubmitSurrender.Cast(PlayerRef)
				EndIf
			EndIf
		EndIf
	Else
		Debug.SendAnimationEvent(PlayerRef, "JumpLand")
		_SLQuest.Escape2Chance()
; // Code for what happens on success
		If (SuccessChance.GetValue() >= SuccessRoll.GetValue())
			If(_SLConfig.debugActive)
				Debug.Notification(SuccessChance.GetValue() + "% success chance, rolled under with " + SuccessRoll.GetValue() + "%.  Success!")
			EndIf
			AdvanceSkill("Lockpicking", (_SLConfig.Escape + 1.0))
			Int Cuffs = PlayerRef.GetItemCount(_SLSubmitCuffs)
			PlayerRef.RemoveItem(_SLSubmitCuffs, Cuffs, true)
			If(_SLConfig.debugActive)
				Debug.Notification("Your hands have been freed!")
			EndIf
			Game.EnablePlayerControls()
		Else
; // Code for what happens on failure
			If(_SLConfig.debugActive)
				Debug.Notification(SuccessChance.GetValue() + "% success chance, rolled too high with " + SuccessRoll.GetValue() + "%.  Failure!")
			EndIf
			AdvanceSkill("Lockpicking", 0.01)
			EscapeBonus.SetValue(EscapeBonus.GetValue() + 1.0)
			_SLScene.WRT(0.1)
			If ((PlayerRef.HasPerk(QuickHands) && (SuccessRoll.GetValue() - SuccessChance.GetValue()) >= (50 + _SLConfig.CDifficulty)) || (!PlayerRef.HasPerk(QuickHands) && (SuccessRoll.GetValue() - SuccessChance.GetValue()) >= (25 + _SLConfig.CDifficulty)))
				If (_SLConfig.RepeatActive)
					If(_SLConfig.debugActive)
						Debug.Notification("Your attempted escape may not have gone unnoticed...")
					EndIf
					_SLSubmitSurrenderGlobal.SetValue(1)
					_SLSubmitAssign.Cast(PlayerRef)
					_SLSubmitSurrender.Cast(PlayerRef)
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent